Perfect Squares

Perfect Squares

Given a positive integer n, find the least number of perfect square numbers (for example, 1, 4, 9, 16, ...) which sum to n.

For example, given n = 12, return 3 because 12 = 4 + 4 + 4; given n = 13, return 2 because 13 = 4 + 9.

Credits:
Special thanks to @jianchao.li.fighter for adding this problem and creating all test cases.

解析:

递归求解每个状态,开始直接递归求解,因为有很多重复计算,超时,后来开辟一个dp数组记录每个状态的值减少冗余计算。


代码:

class Solution {
public:
    int numSquares(int n) {
        int ans=INT_MAX;
        
        vectordp(n+1,0);
        dp[1]=1;
        return Numsq(n,dp);
        
    }
    
    int Numsq(int n,vector&dp)
    {
        int ans=INT_MAX;
        int temp=sqrt(n);
        if (temp*temp==n)
        return 1;
        for (int i=temp; i>0; i--)
        {
            int tempans=0;
            if (dp[n-i*i])
            {
                tempans=dp[n-i*i];
            }
            else
            {
                dp[n-i*i]=Numsq(n-i*i,dp);
            }
            
            ans=min(ans,dp[n-i*i]+1);
        }
        dp[n]=ans;
        return ans;
    }
    
};



你可能感兴趣的:(leetcode,ACM)